//////////////////////////////////////////////////////////////////////
// Created by SmartDesign Tue Feb  5 10:08:44 2019
// Version: v12.0 12.500.0.22
//////////////////////////////////////////////////////////////////////

`timescale 1ns / 100ps

// AR0330_MIPI_IF
module AR0330_MIPI_IF(
    // Inputs
    PADN,
    PADP,
    PAD_I_N,
    PAD_I_P,
    SYS_CLOCK,
    cam_ddr_wr_ack,
    cam_ddr_wr_done,
    display_ddr_address_i,
    nRESET_I,
    reset_mipi,
    // Outputs
    DC_FRM_BUFF_DDR_ADDR_o,
    Image_Frame_end_o,
    Image_Frame_start_o,
    Image_Line_end_o,
    Image_Line_vld_o,
    Image_line_start_o,
    L1_LP_DATA,
    L1_LP_DATA_N,
    L2_LP_DATA,
    L2_LP_DATA_N,
    L3_LP_DATA,
    L3_LP_DATA_N,
    PLL_LOCK_0,
    cam_ddr_address,
    cam_ddr_bytes_to_write,
    cam_ddr_wr_req,
    display_control_en_o,
    parallel_clock,
    pixel_out_o,
    pixel_vld_o
);

//--------------------------------------------------------------------
// Input
//--------------------------------------------------------------------
input         PADN;
input         PADP;
input  [3:0]  PAD_I_N;
input  [3:0]  PAD_I_P;
input         SYS_CLOCK;
input         cam_ddr_wr_ack;
input         cam_ddr_wr_done;
input  [31:0] display_ddr_address_i;
input         nRESET_I;
input         reset_mipi;
//--------------------------------------------------------------------
// Output
//--------------------------------------------------------------------
output [31:0] DC_FRM_BUFF_DDR_ADDR_o;
output        Image_Frame_end_o;
output        Image_Frame_start_o;
output        Image_Line_end_o;
output        Image_Line_vld_o;
output        Image_line_start_o;
output        L1_LP_DATA;
output        L1_LP_DATA_N;
output        L2_LP_DATA;
output        L2_LP_DATA_N;
output        L3_LP_DATA;
output        L3_LP_DATA_N;
output        PLL_LOCK_0;
output [31:0] cam_ddr_address;
output [15:0] cam_ddr_bytes_to_write;
output        cam_ddr_wr_req;
output        display_control_en_o;
output        parallel_clock;
output [31:0] pixel_out_o;
output        pixel_vld_o;
//--------------------------------------------------------------------
// Nets
//--------------------------------------------------------------------
wire   [7:0]  AR0330_Parallel_IF_0_data_out_o;
wire   [31:0] bus_cdc_synchornizer_hdl_0_output_bus_o;
wire   [31:0] bus_cdc_synchornizer_hdl_1_output_bus_o;
wire          cam_data_pack_0_ddr_start_proc_o;
wire   [31:0] cam_data_pack_0_start_ddr_address_o;
wire   [31:0] cam_ddr_address_net_0;
wire   [15:0] cam_ddr_bytes_to_write_net_0;
wire          cam_ddr_wr_ack;
wire          cam_ddr_wr_done;
wire          cam_ddr_wr_req_net_0;
wire   [31:0] DC_FRM_BUFF_DDR_ADDR_o_net_0;
wire          display_control_en_o_net_0;
wire   [31:0] display_ddr_address_i;
wire          Image_Frame_end_o_net_0;
wire          Image_Frame_start_o_net_0;
wire          Image_Line_end_o_net_0;
wire          Image_line_start_o_net_0;
wire          Image_Line_vld_o_net_0;
wire          L1_LP_DATA_0;
wire          L1_LP_DATA_N_0;
wire          L2_LP_DATA_0;
wire          L2_LP_DATA_N_0;
wire          L3_LP_DATA_0;
wire          L3_LP_DATA_N_0;
wire          nRESET_I;
wire   [3:0]  PAD_I_N;
wire   [3:0]  PAD_I_P;
wire          PADN;
wire          PADP;
wire          parallel_clock_net_0;
wire   [31:0] pixel_out_o_net_0;
wire          pixel_vld_o_net_0;
wire          PLL_LOCK_0_net_0;
wire          reset_mipi;
wire          SYS_CLOCK;
wire          cam_ddr_wr_req_net_1;
wire          Image_Frame_end_o_net_1;
wire          Image_Frame_start_o_net_1;
wire          Image_Line_end_o_net_1;
wire          display_control_en_o_net_1;
wire          pixel_vld_o_net_1;
wire          Image_Line_vld_o_net_1;
wire          PLL_LOCK_0_net_1;
wire          parallel_clock_net_1;
wire          L2_LP_DATA_N_0_net_0;
wire          L1_LP_DATA_0_net_0;
wire          L2_LP_DATA_0_net_0;
wire          L3_LP_DATA_N_0_net_0;
wire          L3_LP_DATA_0_net_0;
wire          L1_LP_DATA_N_0_net_0;
wire          Image_line_start_o_net_1;
wire   [15:0] cam_ddr_bytes_to_write_net_1;
wire   [31:0] cam_ddr_address_net_1;
wire   [31:0] DC_FRM_BUFF_DDR_ADDR_o_net_1;
wire   [31:0] pixel_out_o_net_1;
//--------------------------------------------------------------------
// TiedOff Nets
//--------------------------------------------------------------------
wire   [10:0] obj_w_const_net_0;
//--------------------------------------------------------------------
// Constant assignments
//--------------------------------------------------------------------
assign obj_w_const_net_0 = 11'h140;
//--------------------------------------------------------------------
// Top level output port assignments
//--------------------------------------------------------------------
assign cam_ddr_wr_req_net_1         = cam_ddr_wr_req_net_0;
assign cam_ddr_wr_req               = cam_ddr_wr_req_net_1;
assign Image_Frame_end_o_net_1      = Image_Frame_end_o_net_0;
assign Image_Frame_end_o            = Image_Frame_end_o_net_1;
assign Image_Frame_start_o_net_1    = Image_Frame_start_o_net_0;
assign Image_Frame_start_o          = Image_Frame_start_o_net_1;
assign Image_Line_end_o_net_1       = Image_Line_end_o_net_0;
assign Image_Line_end_o             = Image_Line_end_o_net_1;
assign display_control_en_o_net_1   = display_control_en_o_net_0;
assign display_control_en_o         = display_control_en_o_net_1;
assign pixel_vld_o_net_1            = pixel_vld_o_net_0;
assign pixel_vld_o                  = pixel_vld_o_net_1;
assign Image_Line_vld_o_net_1       = Image_Line_vld_o_net_0;
assign Image_Line_vld_o             = Image_Line_vld_o_net_1;
assign PLL_LOCK_0_net_1             = PLL_LOCK_0_net_0;
assign PLL_LOCK_0                   = PLL_LOCK_0_net_1;
assign parallel_clock_net_1         = parallel_clock_net_0;
assign parallel_clock               = parallel_clock_net_1;
assign L2_LP_DATA_N_0_net_0         = L2_LP_DATA_N_0;
assign L2_LP_DATA_N                 = L2_LP_DATA_N_0_net_0;
assign L1_LP_DATA_0_net_0           = L1_LP_DATA_0;
assign L1_LP_DATA                   = L1_LP_DATA_0_net_0;
assign L2_LP_DATA_0_net_0           = L2_LP_DATA_0;
assign L2_LP_DATA                   = L2_LP_DATA_0_net_0;
assign L3_LP_DATA_N_0_net_0         = L3_LP_DATA_N_0;
assign L3_LP_DATA_N                 = L3_LP_DATA_N_0_net_0;
assign L3_LP_DATA_0_net_0           = L3_LP_DATA_0;
assign L3_LP_DATA                   = L3_LP_DATA_0_net_0;
assign L1_LP_DATA_N_0_net_0         = L1_LP_DATA_N_0;
assign L1_LP_DATA_N                 = L1_LP_DATA_N_0_net_0;
assign Image_line_start_o_net_1     = Image_line_start_o_net_0;
assign Image_line_start_o           = Image_line_start_o_net_1;
assign cam_ddr_bytes_to_write_net_1 = cam_ddr_bytes_to_write_net_0;
assign cam_ddr_bytes_to_write[15:0] = cam_ddr_bytes_to_write_net_1;
assign cam_ddr_address_net_1        = cam_ddr_address_net_0;
assign cam_ddr_address[31:0]        = cam_ddr_address_net_1;
assign DC_FRM_BUFF_DDR_ADDR_o_net_1 = DC_FRM_BUFF_DDR_ADDR_o_net_0;
assign DC_FRM_BUFF_DDR_ADDR_o[31:0] = DC_FRM_BUFF_DDR_ADDR_o_net_1;
assign pixel_out_o_net_1            = pixel_out_o_net_0;
assign pixel_out_o[31:0]            = pixel_out_o_net_1;
//--------------------------------------------------------------------
// Component instances
//--------------------------------------------------------------------
//--------bus_cdc_synchornizer_hdl
bus_cdc_synchornizer_hdl bus_cdc_synchornizer_hdl_0(
        // Inputs
        .DEST_CLOCK_I ( parallel_clock_net_0 ),
        .input_bus_i  ( display_ddr_address_i ),
        // Outputs
        .output_bus_o ( bus_cdc_synchornizer_hdl_0_output_bus_o ) 
        );

//--------bus_cdc_synchornizer_hdl
bus_cdc_synchornizer_hdl bus_cdc_synchornizer_hdl_1(
        // Inputs
        .DEST_CLOCK_I ( SYS_CLOCK ),
        .input_bus_i  ( cam_data_pack_0_start_ddr_address_o ),
        // Outputs
        .output_bus_o ( bus_cdc_synchornizer_hdl_1_output_bus_o ) 
        );

//--------cam_ar0331_mipi
cam_ar0331_mipi cam_ar0330_mipi_0(
        // Inputs
        .reset_mipi     ( reset_mipi ),
        .PADP           ( PADP ),
        .PADN           ( PADN ),
        .PAD_I_P        ( PAD_I_P ),
        .PAD_I_N        ( PAD_I_N ),
        // Outputs
        .PLL_LOCK_0     ( PLL_LOCK_0_net_0 ),
        .frame_start    ( Image_Frame_start_o_net_0 ),
        .line_start     ( Image_line_start_o_net_0 ),
        .frame_end      ( Image_Frame_end_o_net_0 ),
        .line_end       ( Image_Line_end_o_net_0 ),
        .line_valid_o   ( Image_Line_vld_o_net_0 ),
        .parallel_clock ( parallel_clock_net_0 ),
        .L3_LP_DATA_N   ( L3_LP_DATA_N_0 ),
        .L1_LP_DATA_N   ( L1_LP_DATA_N_0 ),
        .L2_LP_DATA     ( L2_LP_DATA_0 ),
        .L3_LP_DATA     ( L3_LP_DATA_0 ),
        .L1_LP_DATA     ( L1_LP_DATA_0 ),
        .L2_LP_DATA_N   ( L2_LP_DATA_N_0 ),
        .data_out_o     ( AR0330_Parallel_IF_0_data_out_o ) 
        );

//--------camdata_ddr_write
camdata_ddr_write cam_data_ddr_write_0(
        // Inputs
        .clock           ( SYS_CLOCK ),
        .nreset          ( nRESET_I ),
        .start_wr_proc   ( cam_data_pack_0_ddr_start_proc_o ),
        .frame_done      ( Image_Frame_start_o_net_0 ),
        .wr_ack          ( cam_ddr_wr_ack ),
        .wr_done         ( cam_ddr_wr_done ),
        .image_base_addr ( bus_cdc_synchornizer_hdl_1_output_bus_o ),
        .obj_w           ( obj_w_const_net_0 ),
        // Outputs
        .wr_req          ( cam_ddr_wr_req_net_0 ),
        .ddr_address     ( cam_ddr_address_net_0 ),
        .bytes_to_write  ( cam_ddr_bytes_to_write_net_0 ) 
        );

//--------camdata_pack
camdata_pack cam_data_pack_0(
        // Inputs
        .CAM_CLOCK_I            ( parallel_clock_net_0 ),
        .DDR_CLOCK_I            ( SYS_CLOCK ),
        .RESET_N_I              ( nRESET_I ),
        .pixel_in_vld_i         ( Image_Line_vld_o_net_0 ),
        .frame_done_i           ( Image_Frame_end_o_net_0 ),
        .frame_start_i          ( Image_Frame_start_o_net_0 ),
        .line_done_i            ( Image_Line_end_o_net_0 ),
        .line_start_i           ( Image_line_start_o_net_0 ),
        .pixel_in_i             ( AR0330_Parallel_IF_0_data_out_o ),
        .display_ddr_address_i  ( bus_cdc_synchornizer_hdl_0_output_bus_o ),
        // Outputs
        .pixel_vld_o            ( pixel_vld_o_net_0 ),
        .ddr_start_proc_o       ( cam_data_pack_0_ddr_start_proc_o ),
        .display_control_en_o   ( display_control_en_o_net_0 ),
        .start_ddr_address_o    ( cam_data_pack_0_start_ddr_address_o ),
        .pixel_out_o            ( pixel_out_o_net_0 ),
        .DC_FRM_BUFF_DDR_ADDR_o ( DC_FRM_BUFF_DDR_ADDR_o_net_0 ) 
        );


endmodule
